package io.controller;


import io.common.constant.Constant;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.dto.CategoriesDTO;
import io.modules.item.service.CategoriesService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;


/**
 * 商品分类表
 *
 * @author Mark #
 * @since 1.0.0 2025-02-13
 */
@RestController
@RequestMapping("api/categories")
@Tag(name="商品分类表")
@CrossOrigin
public class CategoriesController {
    @Autowired
    private CategoriesService categoriesService;

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
        @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
        @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
        @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
        @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String")
    })
    public Result<PageData<CategoriesDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        PageData<CategoriesDTO> page = categoriesService.page(params);
        return new Result<PageData<CategoriesDTO>>().ok(page);
    }

    @GetMapping("{id}")

    public Result<CategoriesDTO> get(@PathVariable("id") Long id){
        CategoriesDTO data = categoriesService.get(id);
        return new Result<CategoriesDTO>().ok(data);
    }

    @PostMapping
    @Operation(summary = "保存")

    public Result save(@RequestBody CategoriesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        categoriesService.save(dto);

        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")

    public Result update(@RequestBody CategoriesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        categoriesService.update(dto);

        return new Result();
    }

    @DeleteMapping("{id}")
    @Operation(summary = "删除")

    public Result delete(@PathVariable Long id){

        Long[] ids = new Long[] { id };
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        categoriesService.delete(ids);
        return new Result();
    }



}
